<button mat-raised-button color="accent" (click)="openDialog()" class="Add">Add</button>
<div *ngIf="dataSource?.filteredData?.length" class="container">
  <div style="margin-top: 10px;">
    <mat-form-field appearance="standard">
      <mat-label>Filter</mat-label>
      <input matInput (keyup)="applyFilter($event)" placeholder="Ex. Mia" #input>
    </mat-form-field>
    
    <div class="mat-elevation-z8">
      <table mat-table [dataSource]="dataSource" matSort>
    
        <!-- Name Column -->
        <ng-container matColumnDef="FirstName">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> FirstName </th>
          <td mat-cell  *matCellDef="let row"> <a  [routerLink]="'/' + row.id"> {{row.FirstName}} </a> </td>
        </ng-container>
    
        <!-- Last Name Column -->
        <ng-container matColumnDef="LastName">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> LastName </th>
          <td mat-cell *matCellDef="let row"> {{row.LastName}} </td>
        </ng-container>
    
        <!-- Email Column -->
        <ng-container matColumnDef="Email">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Email </th>
          <td mat-cell *matCellDef="let row"> {{row.Email}} </td>
        </ng-container>

        <!--Action coloumn-->
        <ng-container matColumnDef="action">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> Action </th>
          <td mat-cell *matCellDef="let row"> 
            <button mat-icon-button (click)="editUser(row)" color="primary">
              <mat-icon>edit</mat-icon>
            </button>

            <button (click)="deleteUser(row.id)" mat-icon-button color="warn">
              <mat-icon>delete</mat-icon>
            </button>
          </td>
        </ng-container>

  
    
        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
    
        <!-- Row shown when there is no matching data. -->
        <tr class="mat-row" *matNoDataRow>
          <td class="mat-cell" colspan="4">No data matching the filter "{{input.value}}"</td>
        </tr>
      </table>
    
      <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" aria-label="Select page of users"></mat-paginator>
    </div>
  
  </div>
</div>
<div *ngIf="!dataSource || !dataSource.filteredData || !dataSource.filteredData.length">
  <span>No User available</span>
</div>